/**
 * A ScreenSaver similar to old DVD Player screen savers.
 * This screen saver can be exited after pressing the escape key or "Q".
 * 8 Random objects move around the screen in a whole manner of ways.
 * The authors names and ID numbers scroll across the screen.
 * The current date & time is displayed at random locations on the screen.
 * The thread speed is 0.5 updates per second, we would have preferred a faster thread speed.
 * Press "Run" to activate.
 * 
 * @author Daniel O'Shea (16161777)
 * @author Sean McBrearty (15162966)
 * 
 * Lab week 9
 * 20/03/2017 15:00
 * Last modified: 16:30 30/03/2017
 * 
 * @version 8.2
 */
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import javax.swing.JFrame;
import javax.swing.JPanel;
import java.util.Random;

public class ScreenSaver extends JPanel {

    private int xDVD = 0;
    private int yDVD = 200;
    private final int DVDSize = 1000;     
    private final int X_DVD_DELTA = 50;
    private final int Y_DVD_DELTA = 50;
    private final int DVD_SIZE = 100;
    private boolean starting = true;
    private int xText = 400;
    private final int yText = 40;
    private final int xOval = 250;
    private int yOval = 60;
    private final int yOvalUpdate = 15;
    
    @Override
    public void paintComponent(Graphics g) {
        super.paintComponent(g);

        Random rng = new Random();    
        int screenWidth = getWidth();
        int screenHeight = getHeight();

        g.setColor(Color.WHITE);
        int xPos = rng.nextInt(screenWidth);
        int yPos = rng.nextInt(screenHeight);
        
        g.drawArc(xOval, yOval+=yOvalUpdate, 100, 50, 180, 360);
        yOval = (yOval < screenHeight) ? yOval + yOvalUpdate : -200; 
        
        g.drawArc(xOval+100, yOval+=yOvalUpdate, 100, 50, 180, 360);
        yOval = (yOval < screenHeight) ? yOval + yOvalUpdate : -200;
        
        g.drawArc(xOval+200, yOval+=yOvalUpdate, 100, 50, 180, 360);
        yOval = (yOval < screenHeight) ? yOval + yOvalUpdate : -200;
        
        if (starting){
            xDVD += X_DVD_DELTA;
         
            System.out.print("right ");
            
        g.setColor(Color.YELLOW);
        g.fillArc(xDVD+82, yDVD-5, DVD_SIZE, DVD_SIZE, DVDSize / 2, 360 );
       
        g.setColor(Color.BLACK);
        g.drawString("DVD MEDIA", xDVD + DVD_SIZE, yDVD + DVD_SIZE/2);
        }
        
        if (xDVD > screenWidth - 200 ){
       
        starting = false;
        yDVD -= Y_DVD_DELTA;
            
        System.out.print("up ");
            
        g.setColor(Color.YELLOW);
        g.fillArc(xDVD+82, yDVD-5, DVD_SIZE, DVD_SIZE, DVDSize / 2, 360 );
        
        g.setColor(Color.BLACK);
        g.drawString("DVD MEDIA", xDVD + DVD_SIZE, yDVD + DVD_SIZE/2);
        }
       
        if (yDVD < 30 ){    
            xDVD -= X_DVD_DELTA;
            
            System.out.print("left ");
            
        g.setColor(Color.YELLOW);
        g.fillArc(xDVD+82, yDVD-5, DVD_SIZE, DVD_SIZE, DVDSize / 2, 360 );
       
        g.setColor(Color.BLACK);
        g.drawString("DVD MEDIA", xDVD + DVD_SIZE, yDVD + DVD_SIZE/2);
        }
        
        if (xDVD < -60){
             yDVD += Y_DVD_DELTA;
        g.setColor(Color.YELLOW);
        g.fillArc(xDVD+82, yDVD-5, DVD_SIZE, DVD_SIZE, DVDSize / 2, 360 );
        
        System.out.print("down");
        
        g.setColor(Color.BLACK);
        g.drawString("DVD MEDIA", xDVD + DVD_SIZE, yDVD + DVD_SIZE/2);   
        }
        
        if (yDVD > screenHeight-110){
             xDVD += X_DVD_DELTA;
           
        g.setColor(Color.YELLOW);
        g.fillArc(xDVD+82, yDVD-5, DVD_SIZE, DVD_SIZE, DVDSize / 2, 360 );
        
        g.setColor(Color.BLACK);
        g.drawString("DVD MEDIA", xDVD + DVD_SIZE, yDVD + DVD_SIZE/2);   
        }
        
        g.setFont(new Font("times new roman", Font.BOLD, 24));
        g.setColor(Color.CYAN);
        
        g.drawString("Daniel O'Shea 16161777 \n Sean McBrearty 15162966", xText += 5, yText);
        xText = (xText < screenWidth) ? xText + 40 : -500; 
        
        g.setColor(Color.WHITE);
        g.setFont(new Font("serif", Font.BOLD, 38));
        g.drawString("Press ESC button to exit",
                rng.nextInt(screenWidth - xPos), rng.nextInt(screenHeight - yPos));
        
        g.setColor(Color.magenta);
        g.drawRect(xPos, yPos, xPos, yPos);
        
        DateFormat dateFormat = new SimpleDateFormat("dd/MM/yyyy HH:mm:ss");
        Date date = new Date();
        g.setFont(new Font("italic", Font.ITALIC, 32));
        g.drawString(dateFormat.format(date),
                rng.nextInt(screenWidth - xPos+100), rng.nextInt(screenHeight - yPos +100));
        }
    
    public static void main(String args[]) {
        JFrame frame = new JFrame("DVD MEDIA");
        
        ScreenSaver screenSaverPanel = new ScreenSaver();
        screenSaverPanel.setBackground(Color.BLACK);

        KeyHandler keyHandler1 = new KeyHandler();
        
        frame.add(screenSaverPanel);
        frame.addKeyListener(keyHandler1);
        frame.setExtendedState(JFrame.MAXIMIZED_BOTH);   
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setUndecorated(true);
        frame.pack();
        frame.setVisible(true);                         

        do { 
            frame.repaint();
            try {
                Thread.sleep(500);     
            } catch (InterruptedException interruptedException) {
            }
        } while (true);
    }
} 

class KeyHandler implements KeyListener {

    @Override
    public void keyPressed(KeyEvent e) {
        if ((e.getKeyCode()==KeyEvent.VK_ESCAPE) || e.getKeyCode()==KeyEvent.VK_Q) {
            System.exit(0);
        }
    }
    
    @Override
    public void keyTyped(KeyEvent ke) {
       }
    
    @Override
    public void keyReleased(KeyEvent ke) {
        }
}